/*
 * Windows utilities based on BLT 2.4q BltWinUtil.c and bltWinDraw.c
 *
 * Copyright 1998 by Bell Labs Innovations for Lucent Technologies.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided
 * that the above copyright notice appear in all copies and that both that the
 * copyright notice and warranty disclaimer appear in supporting documentation,
 * and that the names of Lucent Technologies any of their entities not be used
 * in advertising or publicity pertaining to distribution of the software
 * without specific, written prior permission.
 *
 * Lucent Technologies disclaims all warranties with regard to this software,
 * including all implied warranties of merchantability and fitness.  In no
 * event shall Lucent Technologies be liable for any special, indirect or
 * consequential damages or any damages whatsoever resulting from loss of use,
 * data or profits, whether in an action of contract, negligence or other
 * tortuous action, arising out of or in connection with the use or performance
 * of this software. 
 *	
 */

#include <windows.h>
/* #include "tkInt.h" */
/* #include "tkPlatDecls.h" */

/*
#undef STD_FONT
#undef STD_FONT_SMALL
#undef STD_FONT_LARGE
#undef STD_COLOR_NORMAL_BG
#undef STD_COLOR_NORMAL_FG
#undef STD_COLOR_TEXT_FG
#undef STD_COLOR_SELECT_BG

#define STD_FONT                "Arial 8"
#define STD_FONT_SMALL          "Arial 6"
#define STD_FONT_LARGE          "Arial 12"
#define STD_COLOR_NORMAL_BG     "SystemButtonFace"
#define STD_COLOR_NORMAL_FG     "SystemButtonText"
#define STD_COLOR_TEXT_FG       "SystemWindowText"
#define STD_COLOR_SELECT_BG     "SystemHighlight"
*/

void *
calloc(
    unsigned int nElems, 
    unsigned int sizeOfElem)
{
    void *array;
    unsigned int nBytes;

    nBytes = nElems * sizeOfElem;
    array = Tcl_Alloc(nBytes);
    memset(array, 0, nBytes);
    return array;
}

void
newXRaiseWindow(
    Display *display, 
    Window window)
{
    HWND hWnd;

    hWnd = Tk_GetHWND(window);
    display->request++;
    SetWindowPos(hWnd, HWND_TOP, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
}

void
XReparentWindow(
    Display *display,
    Window window,
    Window parent,
    int x,
    int y)
{
    HWND child, newParent;

    child = Tk_GetHWND(window);
    newParent = Tk_GetHWND(parent);
    SetParent(child, newParent);
    SetWindowLong(child, GWL_STYLE, WS_CHILD | WS_CLIPCHILDREN |
	WS_CLIPSIBLINGS);

    XMoveWindow(display, window, x, y);
    XRaiseWindow(display, window);
    XMapWindow(display, window);
}
